<%@ taglib uri="http://www.sas.com/taglib/sas-uis"  prefix="sas-uis"   %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="com.sas.framework.webapp.util.WebKey" %>
<%@ page import="com.sas.svcs.authentication.client.SecurityContext" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.sas.sso.fraud.webapp.servlet.BaseServlet" %>

<%
    final String SNALITE = "SNALITE";
    final String HTML5LITE = "HTML5LITE";
    final String FULL_SNA_URL = "index.html";
    final String SNALITE_URL = "socialnetworkdiagram.jsp?";
    final String HTML5LITE_URL = "litediagram.jsp?";
    final String NOT_SUPPORTED_URL = "notsupported.jsp?";
     
    SecurityContext secCtx = (SecurityContext)session.getAttribute(WebKey.SECURITY_CONTEXT);
    String pfsSessionID = secCtx.getKey();
    String logoffURL = URLEncoder.encode("Logoff?saspfs_sessionid=" + pfsSessionID, "UTF-8");
    String title = "SAS Social Network Analysis";
    session.setAttribute("logoffURL", logoffURL); 
    
    String requestingPage = request.getParameter("requestingPage");
    String userAgent = request.getHeader("User-Agent");
    boolean devMode = Boolean.parseBoolean(System.getProperty("sas.development.mode"));
    boolean browserSupported = false;

    /** set the content-language header to user locale */
    BaseServlet.setLanguageHeader(request, response);
                                         
    StringBuilder redirectURL = new StringBuilder(FULL_SNA_URL);
    
    if (userAgent != null && userAgent.length() > 0) {
    	String ua = userAgent.toLowerCase();
        String[] supportedBrowsers = {"firefox", "msie 9"};
        
    	for(String s : supportedBrowsers) {
    		if(ua.indexOf(s) > -1) browserSupported = true;
    	}
    }
    
    if (devMode == true){       
        if (SNALITE.equalsIgnoreCase(requestingPage)){
            redirectURL = new StringBuilder(SNALITE_URL);
            redirectURL.append(request.getQueryString());
            response.sendRedirect(redirectURL.toString());
        }else if (HTML5LITE.equalsIgnoreCase(requestingPage)){
        	if(!browserSupported) {
                redirectURL = new StringBuilder(NOT_SUPPORTED_URL);
                String UAEnc = URLEncoder.encode(userAgent);
                redirectURL.append("agent=" + UAEnc);
                response.sendRedirect( redirectURL.toString() );
            } else {
	            redirectURL = new StringBuilder(HTML5LITE_URL);
	            redirectURL.append(request.getQueryString());
	            response.sendRedirect(redirectURL.toString());
            }
        }
        
    }

    if(!browserSupported) {
    	redirectURL = new StringBuilder(NOT_SUPPORTED_URL);
    	String UAEnc = URLEncoder.encode(userAgent);
    	redirectURL.append("agent=" + UAEnc);
    	response.sendRedirect( redirectURL.toString() );
    }
%>

<jsp:include page="<%=FULL_SNA_URL%>"></jsp:include>
