
require([
    'sna/model/ApplicationContextModel',
    "dojo/parser",
    "dojo/ready", 
    'sna/util/OverlayUtil',
    'sna/model/widgets/RegistryDump/RegistryDump',
    'dojo/dom-construct',
    'dijit/registry',
    'sna/data/SessionMonitorData',
    'sna/controller/SessionMonitorController',
    'sna/data/ContextPreferenceData',
    'sna/controller/AlertDetailsFacetController',
    'sna/controller/ControllerRepository',
    'sna/networkview/controller/NetworkMapController',
    'sna/networkview/controller/UnchartedNodesController',
    'sna/networkview/controller/NetworkController',
    'sna/networkview/controller/NetworkFacetController',
    'sna/networkview/controller/NetworkPropertiesController',
    'sna/networkview/controller/NetworkDetailsController',
    'sna/controller/MaximizedChartsController',
    'sna/controller/SNALiteController',
    'sna/controller/AboutWindowController',
    'sna/controller/ViewSwitcherController',
    'sna/controller/RefreshController',
	'sna/controller/DispositionController',
	'sna/controller/ExternalAppController',
    'sna/controller/PrintViewController',
    'sna/controller/AlertDetailsController',
    'dojo/_base/lang',
    'sna/controller/AlertsListFacetController',
    'sna/controller/AlertsViewController',
    'sna/controller/AdvancedSearchController',
    'sna/data/NetworkData',
    'sna/controller/UserController',
    'dojo/dom',
    'sna/data/AlertDetailsData',
    'sna/data/UserPreferenceData',
    'sna/data/AdvancedSearchData',
    'sna/data/DispositionData',
    'sna/data/BizDomainPromptData',
    'sna/data/AlertsViewData',
    'sna/data/UserData',
    'sna/data/CommentData',
    'sna/data/ExternalAppData',
    'sna/controller/BizDomainPromptController',
    'sna/controller/UserPreferenceWindowController',
    'sna/controller/GlobalToolbarController',
    'sna/controller/PageToolbarController',
    'sna/util/I18nUtil',
    'sna/util/DebugUtil',
    'dojo/domReady!'
], function(ApplicationContextModel, parser, ready, OverlayUtil, RegistryDump, domConstruct, registry, sessionMonitorData, SessionMonitorController, contextPreferenceData, AlertDetailsFacetController, controllerRepository, NetworkMapController, UnchartedNodesController, NetworkController, NetworkFacetController, NetworkPropertiesController, NetworkDetailsController,
		    MaximizedChartsController, SNALiteController, AboutWindowController, ViewSwitcherController, RefreshController, 
		    DispositionController, ExternalAppController, PrintViewController, AlertDetailsController, lang, AlertsListFacetController, 
		    AlertsViewController, AdvancedSearchController, networkData, UserController, dom, alertDetailsData, userPreferenceData, advancedSearchData,
		    dispositionData, bizDomainPromptData, alertsViewData, userData, commentData, externalAppData, BizDomainPromptController, UserPreferenceWindowController,
		    GlobalToolbarController, PageToolbarController, I18nUtil, debugUtil) {

    ready(function() {
        parser.parse();
        I18nUtil.parseDOM();
	
    	// empty objects that will contain controllers
    	var alertDetailsController = {}; 
    	var alertsViewController = {}; 
    	var userPreferenceWindowController = {};
    	var advancedSearchController = {};
    	var pageToolbarController = {};
    	var bizDomainPromptController = {};
    	var alertsListFacetController = {};
    	var globalToolbarController = {};
    	var userController = {};
    	var printViewController = {};
    	var dispositionController = {}; 
    	var externalAppController = {};
    	var refreshController = {};
    	var viewSwitcherController = {};
    	var aboutWindowController = {};
    	var snaLiteController = {};
    	var maximizedChartsController = {};
        var unchartedNodesController = {};
    	var networkController = {};
    	var networkFacetController = {};
    	var networkPropertiesController = {};
    	var networkDetailsController = {};
        var networkMapController = {};
        var alertDetailsFacetController = {};
        var sessionMonitorController = {};

        // registry dump
        if( debugUtil.showRegistryDump() === true ) {
            OverlayUtil.hideOverlay();
            var registryDump = new RegistryDump({
            });
            domConstruct.place(registryDump.domNode, 'splash', 'before');
        }

        // define the controllers using mixin's
        lang.mixin(controllerRepository, {
            advancedSearchController: advancedSearchController,
            alertsListFacetController: alertsListFacetController,
            alertDetailsController: alertDetailsController,
            bizDomainPromptController: bizDomainPromptController,
            dispositionController: dispositionController,
            externalAppController: externalAppController,
            globalToolbarController: globalToolbarController,
            maximizedChartsController: maximizedChartsController,
            networkController: networkController,
            networkFacetController: networkFacetController,
            networkMapController: networkMapController,
            networkPropertiesController: networkPropertiesController,
            networkDetailsController: networkDetailsController,
            pageToolbarController: pageToolbarController,
            printViewController: printViewController,
            refreshController: refreshController,
            unchartedNodesController: unchartedNodesController,
            userController: userController,
            userPreferenceWindowController: userPreferenceWindowController,
            viewSwitcherController: viewSwitcherController,
            sessionMonitorController: sessionMonitorController
        });

    	// define the controllers using mixin's
        lang.mixin(alertsViewController, new AlertsViewController({
            alertsListFacetController: alertsListFacetController,
            alertDetailsController: alertDetailsController,
            dispositionController: dispositionController,
            viewSwitcherController: viewSwitcherController,
            externalAppController: externalAppController
        }));

        lang.mixin(sessionMonitorController, new SessionMonitorController({
            userController: userController
        }));

    	lang.mixin(userPreferenceWindowController, new UserPreferenceWindowController({
        }));
    	
    	lang.mixin(alertDetailsController, new AlertDetailsController({
    		dispositionController: dispositionController,
    		networkController: networkController,
    		viewSwitcherController: viewSwitcherController,
    		maximizedChartsController: maximizedChartsController,
            alertDetailsFacetController: alertDetailsFacetController
        }));

        lang.mixin(alertDetailsFacetController, new AlertDetailsFacetController({
            alertDetailsController: alertDetailsController
        }));

        lang.mixin(printViewController, new PrintViewController({
            alertDetailsController:alertDetailsController,
            alertsViewController:alertsViewController
        }));

        lang.mixin(pageToolbarController, new PageToolbarController({
            alertsListFacetController:alertsListFacetController,
            alertsViewController:alertsViewController,
            viewSwitcherController:viewSwitcherController
        }));
    	
    	lang.mixin(advancedSearchController, new AdvancedSearchController({
    		viewSwitcherController: viewSwitcherController
        }));
    	
    	lang.mixin(viewSwitcherController, new ViewSwitcherController({
    		pageToolbarController: pageToolbarController,
    		alertDetailsController: alertDetailsController,
    		alertsViewController: alertsViewController
        }));

        lang.mixin(dispositionController, new DispositionController({
            alertDetailsController:alertDetailsController,
            alertsViewController:alertsViewController,
            viewSwitcherController:viewSwitcherController
        }));
        
        lang.mixin(externalAppController, new ExternalAppController({
        	alertDetailsController: alertDetailsController,
        	alertsViewController: alertsViewController,
        	viewSwitcherController: viewSwitcherController
        }));
    	
    	lang.mixin(bizDomainPromptController, new BizDomainPromptController({
            alertDetailsController:alertDetailsController,
            advancedSearchController: advancedSearchController,
            viewSwitcherController: viewSwitcherController,
            globalToolbarController: globalToolbarController,
            sessionMonitorController: sessionMonitorController
        }));
    	
    	lang.mixin(alertsListFacetController, new AlertsListFacetController({
    		alertsViewController: alertsViewController
        }));
    	
    	lang.mixin(globalToolbarController, new GlobalToolbarController({
    		bizDomainPromptController: bizDomainPromptController,
            userPreferenceWindowController: userPreferenceWindowController,
            advancedSearchController: advancedSearchController,
            printViewController: printViewController,
            refreshController: refreshController,
            aboutWindowController: aboutWindowController,
            userController: userController
        }));
    	
    	lang.mixin(userController, new UserController({
        }));
    	
    	lang.mixin(refreshController, new RefreshController({
    		viewSwitcherController: viewSwitcherController
        }));
    	
    	lang.mixin(aboutWindowController, new AboutWindowController({
        }));
    	
    	lang.mixin(maximizedChartsController, new MaximizedChartsController({
        }));

        lang.mixin(networkMapController, new NetworkMapController({
            networkController: networkController,
            networkFacetController: networkFacetController
        }));
    	
    	lang.mixin(networkController, new NetworkController({
    		networkFacetController: networkFacetController,
    		networkPropertiesController: networkPropertiesController,
    		networkDetailsController: networkDetailsController,
            networkMapController: networkMapController,
            unchartedNodesController: unchartedNodesController,
            viewSwitcherController: viewSwitcherController
        }));
    	lang.mixin(networkFacetController, new NetworkFacetController({
    		networkController: networkController
        }));
    	lang.mixin(networkPropertiesController, new NetworkPropertiesController({
    		networkController: networkController
        }));
    	lang.mixin(networkDetailsController, new NetworkDetailsController({
    		networkController: networkController
        }));
        lang.mixin(unchartedNodesController, new UnchartedNodesController({
            networkController: networkController
        }));


    	lang.mixin(snaLiteController, new SNALiteController({
    		networkController: networkController
        }));
    	
        var useDebugMode = debugUtil.isDebugMode();
        dispositionData.setDebug(useDebugMode);
        bizDomainPromptData.setDebug(useDebugMode);
        contextPreferenceData.setDebug(useDebugMode);
        alertsViewData.setDebug(useDebugMode);
        alertDetailsData.setDebug(useDebugMode);
        advancedSearchData.setDebug(useDebugMode);
        userPreferenceData.setDebug(useDebugMode);
        commentData.setDebug(useDebugMode);
        networkData.setDebug(useDebugMode);
        userData.setDebug(useDebugMode);
        externalAppData.setDebug(useDebugMode);
        sessionMonitorData.setDebug(useDebugMode);

        var errorMode = debugUtil.getWhoIsBroken();
        alertsViewData.setErrorMode(errorMode);
        alertDetailsData.setErrorMode(errorMode);
        contextPreferenceData.setDebug(useDebugMode);
        
        var isSNALiteMode = debugUtil.isSNALiteMode(); // TODO: remove this to snalite controller

        window.onbeforeunload = function (e) {
            if(ApplicationContextModel.get('unsavedChanges') && alertDetailsController.isLoaded()) {
                var message = I18nUtil.get('global_unsavedchanges'),
                    e = e || window.event;
                // For IE and Firefox
                if (e) {
                    e.returnValue = message;
                }

                window.onbeforeunload = function (e) {};

                // For Safari
                return message;
            }
        };

        if (isSNALiteMode === true) {
            snaLiteController.start();
        }
        else {
            bizDomainPromptController.start(true);
            userController.start();
            globalToolbarController.start();
            pageToolbarController.start();
        }
    });
});
