/**
 * @class
 * Handles DOM-level actions for the Page Toolbar
 */
define([
    'sna/util/I18nUtil',
    'dojo/dom-construct',
    'dojo/query',
    'dojo/dom',		
    'dijit/form/Button',
    'dojo/_base/declare',
    'dojo/ready',
    'dijit/registry',
    'dojo/on',
    'dijit/form/DropDownButton',
    'dijit/DropDownMenu',
    'dijit/MenuItem'
], function( i18nUtil, domConstruct, query, dom, Button, declare, ready, registry, on, DropDownButton, DropDownMenu, MenuItem ) {
	return declare([], { 
		constructor: function( args ) {
		    var that = this;
			ready(function() {
				declare.safeMixin(this, args);
				
				that.controller = args.controller;
			});
    	},

        /**
         * Create and show the "Back to Alerts" button
         * @param vertical
         */
		showBackToAlertsButton: function(vertical, submissions) {
			if( !this.d_backToAlertsButton ) {
				var that = this;
				ready(function() {
					that.d_backToAlertsButton = new Button({
                        disabled: true,
                        id: "backtoalertsbutton",
						label: i18nUtil.get('pagetoolbar_back'),
                        iconClass: 'sasSliderArrowPreviousIcon',
						onClick: function() {
						    that.controller.showBackToAlertsButtonClicked(vertical, submissions);
						}
					}, 'backtoalertsbutton');
					that.d_backToAlertsButton.startup();
					
					d_pageToolbarDiv = registry.byId('pagetoolbarcontentpane');
					d_pageToolbarDiv.addChild(that.d_backToAlertsButton, 0);
				});
			}
		},
		
		/**
		 * Destroy the "Back to Alerts" button
		 */
		hideBackToAlertsButton: function() {
			if( this.d_backToAlertsButton ) {
				this.d_backToAlertsButton.destroyRecursive();
				this.d_backToAlertsButton = undefined;
			}
		}
	});
});
